; Call an M-code program at absolute address
;
      INCLUDE "includes/MACS.ASM"

      INIT_AMIGA


        CMPI.B #' ',(A0)  ; check for any characters
        BLT.S Instructions ; print out instructions and exit
        BSR HexA0_D0
        MOVEA.L D0,A1     ; get start address
	JSR	(A1)
	BRA	Exit_prog 
Instructions:             ; print out instructions and exit
        BSR    PRINT
 DC.B '(C) 12.88 by RAKO',10
 DC.B 'Usage: CALL  30000  starts M-code at absolute address 30000 (hex)',10
 DC.B '!!!!!!!!!!! BE VERY CAREFULL WITH THIS COMMAND !!!!!!!!!!!!',10,0
        MOVEQ  #$64,D0    ; signal error
        BRA    Exit_prog  ; and exit

HexA0_D0:                 ; get Hex number from text (A0)  -> D0
        CLR.L D0
; Hack leading spaces
Hack_Blank:
         CMP.B    #' ',(A0)+
         BEQ.S    Hack_Blank
         SUBQ.L   #1,A0
LC6642C:
        MOVE.B (A0)+,D1
        CMPI.B #' ',D1    ; space ?
        BEQ.S LC66454
        CMPI.B #10,D1     ; Line Feed ?
        BEQ.S LC66454
        CMPI.B #'A',D1    ; letter 'A' ?
        BLT.S LC66446
        SUBI.B #55,D1
        BRA.S LC6644A
LC66446:
        SUBI.B #$30,D1    ; generate number from 10 to 15
LC6644A:
        ANDI.B #$F,D1     ; only numbers from 10 to 15 are relevant
        LSL.L #4,D0       ; place for next 4 bits
        OR.B D1,D0        ; insert next 4 bits
        BRA.S LC6642C     ; continue until end of Number
LC66454:RTS

Exit_prog:
        EXIT_AMIGA

        END


